"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _intlReact = require("@cloudflare/intl-react");

var _componentVisuallyHidden = require("@cloudflare/component-visually-hidden");

var _styleConst = require("@cloudflare/style-const");

var _styleContainer = require("@cloudflare/style-container");

var _elements = require("@cloudflare/elements");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SquareCanvas = (0, _styleContainer.createComponent)(function (_ref) {
  var side = _ref.side;
  return {
    width: "".concat(side, "px"),
    height: "".concat(side, "px")
  };
}, 'canvas');
var DEFAULT_HEIGHT = 15; // px

var ARC_THICKNESS = 0.151; // relative to diameter

var ANGLE_STEP = Math.PI / 30; // radians/frame (regulates animation speed)

var MIN_ARC_LENGTH = 0.01; // ratio of full circle

var MAX_ARC_LENGTH = 0.8; // ratio of full circle

function Loading(_ref2) {
  var color = _ref2.color,
      _ref2$size = _ref2.size,
      layoutSize = _ref2$size === void 0 ? '1x' : _ref2$size;
  var canvas = (0, _react.useRef)(null);
  var size = Math.round(DEFAULT_HEIGHT * Number(layoutSize.replace('x', '')));
  (0, _react.useEffect)(function () {
    if (canvas.current) {
      var _canvas$current;

      var ctx = (_canvas$current = canvas.current) === null || _canvas$current === void 0 ? void 0 : _canvas$current.getContext('2d');

      if (!ctx) {
        return; // canvas not available (f.e. in tests)
      }

      ctx.resetTransform(); // Keep it crisp on retina devices

      var scaleFactor = window.devicePixelRatio || 1;
      ctx.scale(scaleFactor, scaleFactor);
      var radius = size / 2;
      var arcThickness = Math.floor(size * ARC_THICKNESS);
      var angleStep = ANGLE_STEP;
      var arcLengthRange = [MIN_ARC_LENGTH, MAX_ARC_LENGTH].map(function (p) {
        return p * 2 * Math.PI;
      });
      var arcProps = [0, // center X
      0, // center Y
      radius - arcThickness / 2 // radius
      ];
      ctx.translate(radius, radius); // center at (0,0)

      ctx.strokeStyle = color || _styleConst.theme.colors.gray[5];
      ctx.lineWidth = arcThickness;
      var arcLength = 0;
      var fwd = true;
      var rafId;

      var onFrame = function onFrame() {
        ctx.clearRect(-radius, -radius, size, size);
        ctx.rotate(angleStep);
        var halfArcLength = Math.max(0, arcLength / 2);
        ctx.beginPath();
        ctx.arc.apply(ctx, arcProps.concat([-halfArcLength, halfArcLength]));
        ctx.stroke();

        if (arcLength <= arcLengthRange[0]) {
          fwd = true;
        }

        if (arcLength >= arcLengthRange[1]) {
          fwd = false;
        }

        arcLength += (fwd ? 1 : -1) * angleStep;
        rafId = requestAnimationFrame(onFrame);
      };

      rafId = requestAnimationFrame(onFrame);
      return function () {
        if (rafId) {
          // stop frame ticker
          cancelAnimationFrame(rafId);
        }
      };
    }
  }, [color, size]);
  var scaledHeight = size * (window.devicePixelRatio || 1);
  return /*#__PURE__*/_react.default.createElement(_elements.Div, null, /*#__PURE__*/_react.default.createElement(SquareCanvas, {
    innerRef: canvas,
    side: size,
    width: scaledHeight,
    height: scaledHeight
  }), /*#__PURE__*/_react.default.createElement(_componentVisuallyHidden.VisuallyHiddenSpan, null, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
    id: "accessibility.content_loading",
    _: "Content loading"
  })));
}

var _default = Loading;
exports.default = _default;